regina::NHandlebody Class Reference
Standard 3-Manifolds

Represents an arbitrary handlebody. More...

`#include <manifold/nhandlebody.h>`

Inheritance diagram for regina::NHandlebody:

## Public Member Functions

| NHandlebody (unsigned long newHandles, bool newOrientable)
| Creates a new handlebody with the given parameters. More...
| NHandlebody (const NHandlebody &cloneMe)
| Creates a clone of the given handlebody. More...
virtual | ~NHandlebody ()
| Destroys this handlebody. More...
unsigned long | getHandles () const
| Returns the number of handles of this handlebody. More...
bool | isOrientable () const
| Returns whether this handlebody is orientable. More...
bool | operator== (const NHandlebody &compare) const
| Determines whether this and the given handlebody represent the same 3-manifold. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
bool | isHyperbolic () const
| Returns whether or not this is a finite-volume hyperbolic manifold. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the common name of this 3-manifold as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the common name of this 3-manifold in TeX format to the given output stream. More...
std::string | getName () const
| Returns the common name of this 3-manifold as a human-readable string. More...
std::string | getTeXName () const
| Returns the common name of this 3-manifold in TeX format. More...
std::string | getStructure () const
| Returns details of the structure of this 3-manifold that might not be evident from its common name. More...
virtual NTriangulation * | construct () const
| Returns a triangulation of this 3-manifold, if such a construction has been implemented. More...
bool | operator< (const NManifold &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold. More...
virtual std::ostream & | writeStructure (std::ostream &out) const
| Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Input and Output
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Detailed Description

Represents an arbitrary handlebody.

All optional NManifold routines except for NManifold::construct() are implemented for this class.

## Constructor & Destructor Documentation

regina::NHandlebody::NHandlebody | ( | unsigned long | newHandles,
|  | bool | newOrientable
| ) |  |

inline

Creates a new handlebody with the given parameters.

Parameters

  newHandles | the number of handles of the handlebody.
  newOrientable | `true` if the handlebody is to be orientable or `false` if the handlebody is to be non-orientable. This must be `true` if the handlebody has no handles.

regina::NHandlebody::NHandlebody | ( | const NHandlebody & | cloneMe | ) |

inline

Creates a clone of the given handlebody.

Parameters

  cloneMe | the handlebody to clone.

regina::NHandlebody::~NHandlebody | ( |  | ) |

inline virtual

Destroys this handlebody.

## Member Function Documentation

NTriangulation * regina::NManifold::construct | ( |  | ) | const

inline virtual inherited

Returns a triangulation of this 3-manifold, if such a construction has been implemented.

If no construction routine has yet been implemented for this 3-manifold (for instance, if this 3-manifold is a Seifert fibred space with sufficiently many exceptional fibres) then this routine will return 0.

The details of which 3-manifolds have construction routines can be found in the notes for the corresponding subclasses of NManifold. The default implemention of this routine returns 0.

Returns
  a triangulation of this 3-manifold, or 0 if the appropriate construction routine has not yet been implemented.

Reimplemented in regina::NSFSpace, regina::NSnapPeaCensusManifold, regina::NLensSpace, and regina::NSimpleSurfaceBundle.

std::string regina::ShareableObject::detail | ( |  | ) | const

inherited

Returns the output from writeTextLong() as a string.

Returns
  a long text representation of this object.

unsigned long regina::NHandlebody::getHandles | ( |  | ) | const

inline

Returns the number of handles of this handlebody.

Returns
  the number of handles.

NAbelianGroup* regina::NHandlebody::getHomologyH1 | ( |  | ) | const

virtual

Returns the first homology group of this 3-manifold, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this 3-manifold then this routine will return 0.

The details of which 3-manifolds have homology calculation routines can be found in the notes for the corresponding subclasses of NManifold. The default implemention of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the first homology group of this 3-manifold, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NManifold.

std::string regina::NManifold::getName | ( |  | ) | const

inherited

Returns the common name of this 3-manifold as a human-readable string.

Returns
  the common name of this 3-manifold.

std::string regina::NManifold::getStructure | ( |  | ) | const

inherited

Returns details of the structure of this 3-manifold that might not be evident from its common name.

For instance, for an orbit space S^3/G this routine might return the full Seifert structure.

This routine may return the empty string if no additional details are deemed necessary.

Returns
  a string describing additional structural details.

std::string regina::NManifold::getTeXName | ( |  | ) | const

inherited

Returns the common name of this 3-manifold in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the common name of this 3-manifold in TeX format.

bool regina::NHandlebody::isHyperbolic | ( |  | ) | const

inline virtual

Returns whether or not this is a finite-volume hyperbolic manifold.

Returns
  `true` if this is a finite-volume hyperbolic manifold, or `false` if not.

Implements regina::NManifold.

bool regina::NHandlebody::isOrientable | ( |  | ) | const

inline

Returns whether this handlebody is orientable.

Returns
  `true` if this handlebody is orientable, or `false` if this handlebody is non-orientable.

bool regina::NManifold::operator< | ( | const NManifold & | compare | ) | const

inherited

Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold.

The ordering imposed on 3-manifolds is purely aesthetic on the part of the author, and is subject to change in future versions of Regina.

The ordering also depends on the particular representation of the 3-manifold that is used. As an example, different representations of the same Seifert fibred space might well be ordered differently.

All that this routine really offers is a well-defined way of ordering 3-manifold representations.

Warning
  Currently this routine is only implemented in full for closed 3-manifolds. For most classes of bounded 3-manifolds, this routine simply compares the strings returned by getName().

Parameters

  compare | the 3-manifold representation with which this will be compared.

Returns
  `true` if and only if this is "smaller" than the given 3-manifold representation.

bool regina::NHandlebody::operator== | ( | const NHandlebody & | compare | ) | const

inline

Determines whether this and the given handlebody represent the same 3-manifold.

Parameters

  compare | the handlebody with which this will be compared.

Returns
  `true` if and only if this and the given handlebody are homeomorphic.

std::string regina::ShareableObject::str | ( |  | ) | const

inherited

Returns the output from writeTextShort() as a string.

Python:
  This implements the `__str__()` function.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toString | ( |  | ) | const

inline inherited

A deprecated alias for str(), which returns the output from writeTextShort() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type str() instead.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toStringLong | ( |  | ) | const

inline inherited

A deprecated alias for detail(), which returns the output from writeTextLong() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type detail() instead.

Returns
  a long text representation of this object.

std::ostream& regina::NHandlebody::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

std::ostream & regina::NManifold::writeStructure | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream.

For instance, for an orbit space S^3/G this routine might write the full Seifert structure.

This routine may write nothing if no additional details are deemed necessary. The default implementation of this routine behaves in this way.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Reimplemented in regina::NSFSpace, and regina::NSnapPeaCensusManifold.

std::ostream& regina::NHandlebody::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

void regina::NManifold::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

void regina::NManifold::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

The documentation for this class was generated from the following file:

- manifold/nhandlebody.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).